<?php

include dirname(__FILE__).'/../../bootstrap/functional.php';

$test = new opTestFunctional(new sfBrowser());

include dirname(__FILE__).'/../../bootstrap/database.php';

$test->setCulture('en');

$test->info('isSecure Test')
  ->get('/diary')
  ->with('request')->begin()
    ->isParameter('module', 'diary')
    ->isParameter('action', 'index')
  ->end()

  ->get('/diary/list')
  ->with('request')->begin()
    ->isParameter('module', 'diary')
    ->isParameter('action', 'list')
  ->end()

  ->get('/diary/search', array('keyword' => 'hoge'))
  ->with('request')->begin()
    ->isParameter('module', 'diary')
    ->isParameter('action', 'search')
  ->end()

  ->get('/diary/3')
  ->with('request')->begin()
    ->isParameter('module', 'diary')
    ->isParameter('action', 'show')
    ->isParameter('id', 3)
  ->end()

  ->get('/diary/listMember/5')
  ->with('request')->begin()
    ->isParameter('module', 'diary')
    ->isParameter('action', 'listMember')
    ->isParameter('id', 5)
  ->end()

  ->get('/diary/listMember/5/2009/6')
  ->with('request')->begin()
    ->isParameter('module', 'diary')
    ->isParameter('action', 'listMember')
    ->isParameter('id', 5)
    ->isParameter('year', 2009)
    ->isParameter('month', 6)
  ->end()

  ->get('/diary/listMember/5/2009/6/1')
  ->with('request')->begin()
    ->isParameter('module', 'diary')
    ->isParameter('action', 'listMember')
    ->isParameter('id', 5)
    ->isParameter('year', 2009)
    ->isParameter('month', 6)
    ->isParameter('day', 1)
  ->end()

  ->get('/diary/listMember/6')
  ->isForwardedTo('member', 'login')

  ->get('/diary/listMember/6/2009/1')
  ->isForwardedTo('member', 'login')

  ->get('/diary/listMember/6/2009/1/1')
  ->isForwardedTo('member', 'login')

  ->get('/diary/listMember/7')
  ->isForwardedTo('member', 'login')

  ->get('/diary/listMember/7/2009/1')
  ->isForwardedTo('member', 'login')

  ->get('/diary/listMember/7/2009/1/1')
  ->isForwardedTo('member', 'login')

  ->get('/diary/listMember')
  ->isForwardedTo('member', 'login')

  ->get('/diary/new')
  ->isForwardedTo('member', 'login')

  ->post('/diary/create')
  ->isForwardedTo('member', 'login')

  ->get('/diary/edit/1')
  ->isForwardedTo('member', 'login')

  ->post('/diary/update/1')
  ->isForwardedTo('member', 'login')

  ->get('/diary/deleteConfirm/1')
  ->isForwardedTo('member', 'login')

  ->post('/diary/delete/1')
  ->isForwardedTo('member', 'login')

  ->post('/diary/1/comment/create')
  ->isForwardedTo('member', 'login')

  ->get('/diary/comment/deleteConfirm/1')
  ->isForwardedTo('member', 'login')

  ->post('/diary/comment/delete/1')
  ->isForwardedTo('member', 'login')
;

$test->info('Public Flag Test')
  ->get('/diary/1')
  ->isForwardedTo('member', 'login')

  ->get('/diary/3')
  ->with('request')->begin()
    ->isParameter('module', 'diary')
    ->isParameter('action', 'show')
    ->isParameter('id', 3)
  ->end()
;

$test->info('Show Test')
  ->get('diary/list')
  ->click('View this diary')
  ->with('request')->begin()
    ->isParameter('module', 'diary')
    ->isParameter('action', 'show')
  ->end()
  ->with('response')->begin()
    ->checkElement('.prevNextLinkLine', true)
    ->checkElement('.prevNextLinkLine .prev', true)
    ->checkElement('.prevNextLinkLine .next', false)
    ->checkElement('.diaryDetailBox .title .heading', 'Open Diary30')
    ->checkElement('#formDiaryComment', false)
  ->end()
;

$keyword = 'Open';
$test->info('Search Test: '.$keyword)
  ->get('diary/list')

  ->click('Search', array('keyword' => $keyword))
  ->with('request')->begin()
    ->isParameter('module', 'diary')
    ->isParameter('action', 'search')
    ->isParameter('keyword', $keyword)
  ->end()
  ->with('response')->begin()
    ->checkElement('.pagerRelative', 2)
    ->checkElement('.pagerRelative .number', '1 - 20 of 30')
    ->checkElement('.pagerRelative .prev', 0)
    ->checkElement('.pagerRelative .next', 2)
    ->checkElement('.partsHeading h3', 'Search Results')
  ->end()

  ->click('Next')
  ->with('request')->begin()
    ->isParameter('module', 'diary')
    ->isParameter('action', 'search')
    ->isParameter('keyword', $keyword)
    ->isParameter('page', 2)
  ->end()
  ->with('response')->begin()
    ->checkElement('.pagerRelative', 2)
    ->checkElement('.pagerRelative .number', '21 - 30 of 30')
    ->checkElement('.pagerRelative .prev', 2)
    ->checkElement('.pagerRelative .next', 0)
    ->checkElement('.partsHeading h3', 'Search Results')
  ->end()

  ->click('Previous')
  ->with('request')->begin()
    ->isParameter('module', 'diary')
    ->isParameter('action', 'search')
    ->isParameter('keyword', $keyword)
    ->isParameter('page', 1)
  ->end()

  ->click('Next', array(), array('position' => 2))
  ->with('request')->begin()
    ->isParameter('module', 'diary')
    ->isParameter('action', 'search')
    ->isParameter('keyword', $keyword)
    ->isParameter('page', 2)
  ->end()

  ->click('Previous', array(), array('position' => 2))
  ->with('request')->begin()
    ->isParameter('module', 'diary')
    ->isParameter('action', 'search')
    ->isParameter('keyword', $keyword)
    ->isParameter('page', 1)
  ->end()
;

$keyword = 'tititi';
$test->info('Search Test: '.$keyword)
  ->get('diary/list')

  ->click('Search', array('keyword' => $keyword))
  ->with('request')->begin()
    ->isParameter('module', 'diary')
    ->isParameter('action', 'search')
    ->isParameter('keyword', $keyword)
  ->end()
  ->with('response')->begin()
    ->checkElement('.pagerRelative', 0)
    ->checkElement('.partsHeading h3', 'Search Results')
    ->checkElement('#diaryList div.body', "\n".'Your search "'.$keyword.'" did not match any diaries.')
  ->end()
;

$test->info('Invalid Id Test')
  ->get('/diary/99999')
  ->isForwardedTo('member', 'login')

  ->get('/diary/listMember/99999')
  ->isForwardedTo('member', 'login')

  ->get('/diary/listMember/99999/2009/1')
  ->isForwardedTo('member', 'login')

  ->get('/diary/listMember/99999/2009/1/1')
  ->isForwardedTo('member', 'login')

  ->get('/diary/edit/99999')
  ->isForwardedTo('member', 'login')

  ->post('/diary/update/99999')
  ->isForwardedTo('member', 'login')

  ->get('/diary/deleteConfirm/99999')
  ->isForwardedTo('member', 'login')

  ->post('/diary/delete/99999')
  ->isForwardedTo('member', 'login')

  ->post('/diary/99999/comment/create')
  ->isForwardedTo('member', 'login')

  ->get('/diary/comment/deleteConfirm/99999')
  ->isForwardedTo('member', 'login')

  ->post('/diary/comment/delete/99999')
  ->isForwardedTo('member', 'login')
;
